// Copyright 2019 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --opt --no-always-opt

var expect_interpreted = true;

class C {
  get prop() {
    return 42;
  }
  set prop(v) {
    assertEquals(expect_interpreted, %IsBeingInterpreted());
    v8TurbofanStaticAssert(v === 43);
  }
}

const c = new C();

function foo() {
  assertEquals(expect_interpreted, %IsBeingInterpreted());
  v8TurbofanStaticAssert(c.prop === 42);
  c.prop = 43;
}

v8PrepareFunctionForOptimization(
    Object.getOwnPropertyDescriptor(C.prototype, 'prop').get);
v8PrepareFunctionForOptimization(
    Object.getOwnPropertyDescriptor(C.prototype, 'prop').set);
v8PrepareFunctionForOptimization(foo);

foo();
foo();
v8OptimizeFunctionOnNextCall(foo);
expect_interpreted = false;
foo();
