// Copyright 2019 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --opt --no-always-opt

function apply(arg) {
  "use strict";
  return arg.apply(this, arguments);
}

function bar() {
  function foo(self, arg) {
    v8TurbofanStaticAssert(arg === 42);
    return %IsBeingInterpreted();
  }
  v8PrepareFunctionForOptimization(foo);

  return apply(foo, 42);
}

v8PrepareFunctionForOptimization(bar);
v8PrepareFunctionForOptimization(apply);
assertTrue(bar());
assertTrue(bar());
v8OptimizeFunctionOnNextCall(bar);
assertFalse(bar());
