// Copyright 2017 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

(function() {
  function foo(x) { return Number.isNaN(x); }

  v8PrepareFunctionForOptimization(foo);
  assertTrue(foo(+undefined));
  assertFalse(foo(undefined));
  v8OptimizeFunctionOnNextCall(foo);
  assertTrue(foo(+undefined));
  assertFalse(foo(undefined));
})();

(function() {
  function foo(x) { return Number.isNaN(+x); }

  v8PrepareFunctionForOptimization(foo);
  assertTrue(foo(+undefined));
  assertFalse(foo(0));
  v8OptimizeFunctionOnNextCall(foo);
  assertTrue(foo(+undefined));
  assertFalse(foo(0));
})();

(function() {
  function foo(x) { return Number.isNaN(x|0); }

  v8PrepareFunctionForOptimization(foo);
  assertFalse(foo(+undefined));
  assertFalse(foo(0));
  v8OptimizeFunctionOnNextCall(foo);
  assertFalse(foo(+undefined));
  assertFalse(foo(0));
})();

(function() {
  function foo(x) { return Number.isNaN("" + x); }

  v8PrepareFunctionForOptimization(foo);
  assertFalse(foo(undefined));
  assertFalse(foo(0));
  v8OptimizeFunctionOnNextCall(foo);
  assertFalse(foo(undefined));
  assertFalse(foo(0));
})();

(function() {
  function foo(x) { return Number.isNaN(0/0); }

  v8PrepareFunctionForOptimization(foo);
  assertTrue(foo());
  assertTrue(foo());
  v8OptimizeFunctionOnNextCall(foo);
  assertTrue(foo());
  assertTrue(foo());
})();
